module FullstackCarouselHelper

  # <%= carousel_page_part(:slideshow, :id => 'myCarousel') do |item| %>  
    # <img src="<%= item.photo.url %>" alt="">
    # <div class="carousel-caption">
    #   <h4><%= item.label %></h4>
    #   <p><%= item.description %></p>
    # </div>
  # <% end %>

  def carousel_page_part(key, options = {}, &block)
    @_fullstack_carousel_counter ||= 0
    @_fullstack_carousel_counter += 1
    
    options = { :arrows => true }.merge(options)
    htmlid  = options.delete(:id) || "carousel-#{key}-#{@_fullstack_carousel_counter}"
    htmlclass   = ((options.delete(:class) || "").split(/\s+/) + [ "carousel" ]).join(" ")
    options[:class] = htmlclass
    options[:id] = htmlid
    arrows  = !!options.delete(:arrows)

    arrows_html = !arrows ? "" : <<-eos
      <a class="carousel-control left" href="##{htmlid}" data-slide="prev">&lsaquo;</a>
      <a class="carousel-control right" href="##{htmlid}" data-slide="next">&rsaquo;</a>    
    eos
  
    items_html = ""
    
    part( key, :schema => :slideshow ) do |slideshow|
        slideshow.items.each_with_index do |item, i|    
           slideshow_page = capture do
             content_tag :div, :class => ( i == 0 ? "item active" : "item" ) do
               yield(item)
             end
           end
           items_html << slideshow_page
        end
    end
    
    content_tag :div, options do
      raw <<-eos
          <div class="carousel-inner">
          #{items_html}
          </div>
          #{arrows_html}
      eos
     
    end
  end
  
end
